#ifndef debugtrace_h
#define debugtrace_h

#ifdef DEBUGTRACE
class FunctionTrace
{
public:
  /** Constructor
   */
  FunctionTrace( const nsCString aName ) 
    : mMethod(aName)
  {
    fprintf(stdout, "[0x%0.8x] FNC: ->%s\n", PR_GetCurrentThread(), mMethod.get() );
  }

  /** Destructor
   */
  virtual ~FunctionTrace()
  {
    fprintf(stdout,"[0x%0.8x] FNC: <-%s\n", PR_GetCurrentThread(), mMethod.get() );
  }

private:
  /** Stores a pointer to the method name
   */
  nsCString mMethod;
};

#define FUNCTION_CLASS_TRACE( x ) FunctionTrace tr( NS_LITERAL_CSTRING( #x ));
#define LOG_CLASS_STR_FUNCTION( x ) fprintf( stdout, "%s\n", (x).get() ); 
#define LOG_STR_ERROR( x )fprintf( stdout, "%s\n", (x).get() ); 

#else
#define FUNCTION_CLASS_TRACE( x )
#define LOG_CLASS_STR_FUNCTION( x )
#define LOG_STR_ERROR( x )
#endif //#ifdef DEBUGTRACE
#endif //#ifndef debugtrace_h
