/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla XHTML + Voice support.
 *
 * The Initial Developer of the Original Code is IBM Corporation.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Chris Cross <xcross@us.ibm.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include <stdio.h>
#include "nsIXTFElement.h"
#include "nsVxmlElement.h"

NS_IMPL_ISUPPORTS2(nsVxmlElement, nsIXTFElement, nsIXTFGenericElement)

NS_HIDDEN_(nsresult)
NS_NewVxmlElement(nsIXTFElement **aResult)
{
  *aResult = new nsVxmlElement();
  if (!*aResult)
    return NS_ERROR_OUT_OF_MEMORY;

  NS_ADDREF(*aResult);
  return NS_OK;
}

nsVxmlElement::nsVxmlElement()
{
  /* member initializers and constructor code */
}

nsVxmlElement::~nsVxmlElement()
{
  /* destructor code */
}

NS_IMETHODIMP nsVxmlElement::GetElementType(PRUint32 *aElementType)
{
  *aElementType = nsIXTFElement::ELEMENT_TYPE_GENERIC_ELEMENT;
  return NS_OK;
}

/* boolean innerVXML (in wstring vxml); */
NS_IMETHODIMP nsVxmlElement::InnerVXML(const PRUnichar *vxml, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

NS_IMETHODIMP nsVxmlElement::OnCreated(nsIXTFGenericElementWrapper *wrapper) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::OnDestroyed(void) {return NS_OK;}
//NS_IMETHODIMP nsVxmlElement::GetElementType(PRUint32 *aElementType);
NS_IMETHODIMP nsVxmlElement::GetIsAttributeHandler(PRBool *aIsAttributeHandler) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::GetScriptingInterfaces(PRUint32 *count, nsIID * **array) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillChangeDocument(nsIDOMDocument *newDoc) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::DocumentChanged(nsIDOMDocument *newDoc) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillChangeParent(nsIDOMElement *newParent) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::ParentChanged(nsIDOMElement *newParent) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillInsertChild(nsIDOMNode *child, PRUint32 index) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::ChildInserted(nsIDOMNode *child, PRUint32 index) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillAppendChild(nsIDOMNode *child) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::ChildAppended(nsIDOMNode *child) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillRemoveChild(PRUint32 index) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::ChildRemoved(PRUint32 index) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillSetAttribute(nsIAtom *name, const nsAString & newValue) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::AttributeSet(nsIAtom *name, const nsAString & newValue) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::WillRemoveAttribute(nsIAtom *name) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::AttributeRemoved(nsIAtom *name) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::BeginAddingChildren(void) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::DoneAddingChildren(void) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::HandleDefault(nsIDOMEvent *aEvent, PRBool *_retval) {return NS_OK;}
NS_IMETHODIMP nsVxmlElement::CloneState(nsIDOMElement *aElement) {return NS_OK;}
