/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla XHTML + Voice support.
 *
 * The Initial Developer of the Original Code is IBM Corporation.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Indiver Dwivedi <dindiver@in.ibm.com>
 *  Mehak Mahajan <mehak.mahajan@in.ibm.com>
 *  Darshana Ingle <daringle@in.ibm.com>
 *  Chris Cross <xcross@us.ibm.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var gConsole = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
var gVxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );


var enablevoice_prefOldVal;
var cancelvoice_prefOldVal;
var keytotalk_prefOldVal;
var talkkeymode_prefOldVal;
var voiceloglevel_prefOldVal;
var enablec3n_prefOldVal;
var browsername_prefOldVal;
var confidencelevel_prefOldVal;
var gender_prefOldVal;
var speed_prefOldVal;
var pitch_prefOldVal;
var volume_prefOldVal;
var highquality_prefOldVal;


var enablevoice_prefNewVal;
var cancelvoice_prefNewVal;
var keytotalk_prefNewVal;
var talkkeymode_prefNewVal;
var voiceloglevel_prefNewVal;
var enablec3n_prefNewVal;
var browsername_prefNewVal;
var confidencelevel_prefNewVal;
var gender_prefNewVal;
var speed_prefNewVal;
var pitch_prefNewVal;
var volume_prefNewVal;
var highquality_prefNewVal;


var enablevoice_prefHasChanged = "false";
var cancelvoice_prefHasChanged = "false";
var keytotalk_prefHasChanged = "false";
var talkkeymode_prefHasChanged = "false";
var voiceloglevel_prefHasChanged = "false";
var enablec3n_prefHasChanged = "false";
var browsername_prefHasChanged = "false";
var confidencelevel_prefHasChanged = "false";
var gender_prefHasChanged = "false";
var speed_prefHasChanged = "false";
var pitch_prefHasChanged = "false";
var volume_prefHasChanged = "false";
var highquality_prefHasChanged = "false";
var deAllocated = false;
var stopped = false;


var myStopObserver = {
   observe : function( newState, topic, data)  {
      newState.QueryInterface(Components.interfaces.nsISupportsPRInt32);
      gConsole.logStringMessage("In Preferences.js myStopObserver ---- VXML State changed to: " + newState.data); 
      if (topic == "notifyOnVxmlStateChange") {               // If observer is notified on the topic we are waiting for
         if (newState.data & Components.interfaces.nsIVxmlInterpreter.STOPPED) { // Check if the state is STOPPED
            stopped = true;
            observerService.removeObserver(myStopObserver ,"notifyOnVxmlStateChange");
	    deAllocateVXM()
         }
      }
   }
};

var myDeallocateObserver = {
   observe : function( newState, topic, data)  {
      newState.QueryInterface(Components.interfaces.nsISupportsPRInt32);
      gConsole.logStringMessage("In Preferences.js myDeallocateObserver ---- VXML State changed to: " + newState.data); 
      if (topic == "notifyOnVxmlStateChange") {       // If observer is notified on the topic we are waiting for
         if (newState.data & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED) { // Check if the state is DEALLOCATED
            deAllocated = true;
            observerService.removeObserver(myDeallocateObserver ,"notifyOnVxmlStateChange");
         }
      }
   }
};

function setDefaultsOnPaneLoad(){
   initVoiceGroup();
   initHighQualityGroup();
   initC3NGroup();

   stopVXM();
// deAllocateVXM();

}

function initVoiceGroup(){

// var cbenablevoice = document.getElementById("enablevoice");
// var chkd = cbenablevoice.getAttribute("checked");

   var state = prefManager.getBoolPref("extensions.xplusv.enablevoice");

   if(state == true){
      enablevoice("false");
   }
   if(state == false){
      enablevoice("true");
   }
}

function initHighQualityGroup(){

   var state = prefManager.getBoolPref("extensions.xplusv.highquality");

   if(state == true){
      highQuality("true");
   }
   if(state == false){
      highQuality("false");
   }
}

function initC3NGroup(){

   var state = prefManager.getBoolPref("extensions.xplusv.enablec3n");

   if(state == true){
      enablec3n("false");
   }
   if(state == false){
      enablec3n("true");
   }
}

function enablevoice(enable){
   var elementcanclevoice = document.getElementById("cancelvoice");
   var elementkeytotalk = document.getElementById("keytotalk");
   var elementtalkkeymode = document.getElementById("talkkeymode");
   var elementvoiceloglevel = document.getElementById("voiceloglevel");

   if(enable == "true"){
      elementcanclevoice.setAttribute("disabled","true");
      elementkeytotalk.setAttribute("disabled","true");
      elementtalkkeymode.setAttribute("disabled","true");
      elementvoiceloglevel.setAttribute("disabled","true");
   }else{
      elementcanclevoice.setAttribute("disabled","false");
      elementkeytotalk.setAttribute("disabled","false");
      elementtalkkeymode.setAttribute("disabled","false");
      elementvoiceloglevel.setAttribute("disabled","false");
   }

}

function toggleVoiceGroup(){

   var cbenablevoice = document.getElementById("enablevoice");
   var chkd = cbenablevoice.getAttribute("checked");
       
   if(chkd == "true"){
      enablevoice("false");
   }else{
      enablevoice("true");
   }
}

function enablec3n(enable){
   var elementbrowsername = document.getElementById("browserName");
   if(enable == "true"){
      elementbrowsername.setAttribute("disabled","true");
   }else{
      elementbrowsername.setAttribute("disabled","false");
   }
}

function toggleC3nGroup(){
        var cbenablec3n = document.getElementById("enablec3n");
   var chkd = cbenablec3n.getAttribute("checked");
   if(chkd == "true"){
      enablec3n("false");
   }else{
      enablec3n("true");
   }  
}

function highQuality(enable){
   var elementspeed = document.getElementById("speed");
   var elementpitch = document.getElementById("pitch");
   var elementvolume = document.getElementById("volume");

   if(enable == "true"){
      elementspeed.setAttribute("disabled","true");
      elementpitch.setAttribute("disabled","true");
      elementvolume.setAttribute("disabled","true");
   }else{
      elementspeed.setAttribute("disabled","false");
      elementpitch.setAttribute("disabled","false");
      elementvolume.setAttribute("disabled","false");
   }

}

function toggleHighQualityGroup(){
   var cbhighquality = document.getElementById("highquality");
   var chkd = cbhighquality.getAttribute("checked");
   if(chkd == "true"){
      highQuality("true");
   }else{
      highQuality("false");
   }
}

/*
function doBeforeAccept(){
    gConsole.logStringMessage("doBeforeAccept called");

   //remember the old values in these variables
   
   //enablevoice_prefOldVal = prefManager.getBoolPref("extensions.xplusv.enablevoice");
   //cancelvoice_prefOldVal = prefManager.getBoolPref("extensions.xplusv.cancelvoice");
   //keytotalk_prefOldVal = prefManager.getIntPref("extensions.xplusv.keytotalk");
   //talkkeymode_prefOldVal = prefManager.getIntPref("extensions.xplusv.talkkeymode");
   //voiceloglevel_prefOldVal = prefManager.getIntPref("extensions.xplusv.voiceloglevel");
   //enablec3n_prefOldVal = prefManager.getBoolPref("extensions.xplusv.enablec3n"); 
   //browsername_prefOldVal = prefManager.getCharPref("extensions.xplusv.browsername");
   //confidencelevel_prefOldVal = prefManager.getIntPref("extensions.xplusv.confidencelevel");
   gender_prefOldVal = prefManager.getIntPref("extensions.xplusv.gender");
   //speed_prefOldVal = prefManager.getIntPref("extensions.xplusv.speed");
   //pitch_prefOldVal = prefManager.getIntPref("extensions.xplusv.pitch");
   //volume_prefOldVal = prefManager.getIntPref("extensions.xplusv.volume");
   //highquality_prefOldVal = prefManager.getBoolPref("extensions.xplusv.highquality");
   //gConsole.logStringMessage(gender_prefOldVal);

}
*/

function doBeforeAccept(){
    gConsole.logStringMessage("doBeforeAccept called");

   //remember the  VXM values / Preference Manager old values in these variables
   var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
   var pd = vxml.getPropertyDescriptor(); 
   
   // Voice parameters
   enablevoice_prefOldVal = prefManager.getBoolPref("extensions.xplusv.enablevoice");
   cancelvoice_prefOldVal = prefManager.getBoolPref("extensions.xplusv.cancelvoice");
   keytotalk_prefOldVal = prefManager.getIntPref("extensions.xplusv.keytotalk");
   
   // Listening modes. 
   var talkkeymode_prefOldVal= pd.getListeningMode(); 
   prefManager.setIntPref("extensions.xplusv.talkkeymode",talkkeymode_prefOldVal);
   
   voiceloglevel_prefOldVal = prefManager.getIntPref("extensions.xplusv.voiceloglevel");
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_CTTS,enablec3n_prefOldVal);
   browsername_prefOldVal = prefManager.getCharPref("extensions.xplusv.browsername");
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_ASR_REJECTION_THRESHOLD,confidencelevel_prefOldVal);
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_GENDER,gender_prefOldVal);
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_PITCH,pitch_prefOldVal);
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_SPEED,speed_prefOldVal);      
   pd.getProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_VOLUME,volume_prefOldVal);
   highquality_prefOldVal = prefManager.getBoolPref("extensions.xplusv.highquality");
   
   gConsole.logStringMessage(gender_prefOldVal);

}

function doDialogAccept(){
   gConsole.logStringMessage("doDialogAccept called");

   enablevoice_prefNewVal = prefManager.getBoolPref("extensions.xplusv.enablevoice");
   cancelvoice_prefNewVal = prefManager.getBoolPref("extensions.xplusv.cancelvoice");
   keytotalk_prefNewVal = prefManager.getIntPref("extensions.xplusv.keytotalk");
   talkkeymode_prefNewVal = prefManager.getIntPref("extensions.xplusv.talkkeymode");
   voiceloglevel_prefNewVal = prefManager.getIntPref("extensions.xplusv.voiceloglevel");
   enablec3n_prefNewVal = prefManager.getBoolPref("extensions.xplusv.enablec3n");
   browsername_prefNewVal = prefManager.getCharPref("extensions.xplusv.browsername");
   confidencelevel_prefNewVal = prefManager.getIntPref("extensions.xplusv.confidencelevel");
   gender_prefNewVal = prefManager.getIntPref("extensions.xplusv.gender");
   speed_prefNewVal = prefManager.getIntPref("extensions.xplusv.speed");
   pitch_prefNewVal = prefManager.getIntPref("extensions.xplusv.pitch");
   volume_prefNewVal = prefManager.getIntPref("extensions.xplusv.volume");
   highquality_prefNewVal = prefManager.getBoolPref("extensions.xplusv.highquality");

   gConsole.logStringMessage(gender_prefNewVal);
   comparePreferences();
   passPreferencesToVXM();
   

}

function comparePreferences(){
   enablevoice_prefHasChanged  = ( enablevoice_prefOldVal == enablevoice_prefNewVal ) ? "false" : "true";
   cancelvoice_prefHasChanged = ( cancelvoice_prefOldVal == cancelvoice_prefNewVal ) ? "false" : "true"; 
   keytotalk_prefHasChanged = ( keytotalk_prefOldVal == keytotalk_prefNewVal ) ? "false" : "true";
   talkkeymode_prefHasChanged = ( talkkeymode_prefOldVal == talkkeymode_prefNewVal ) ? "false" : "true";
   voiceloglevel_prefHasChanged = ( voiceloglevel_prefOldVal == voiceloglevel_prefNewVal ) ? "false" : "true";
   enablec3n_prefHasChanged = ( enablec3n_prefOldVal == enablec3n_prefNewVal ) ? "false" : "true";
   browsername_prefHasChanged = ( browsername_prefOldVal == browsername_prefNewVal ) ? "false" : "true";
   confidencelevel_prefHasChanged = ( confidencelevel_prefOldVal == confidencelevel_prefNewVal ) ? "false" : "true";
   gender_prefHasChanged = ( gender_prefOldVal == gender_prefNewVal ) ? "false" : "true";
   speed_prefHasChanged = ( speed_prefOldVal == speed_prefNewVal ) ? "false" : "true";
   pitch_prefHasChanged = ( pitch_prefOldVal == pitch_prefNewVal ) ? "false" : "true";
   volume_prefHasChanged = ( volume_prefOldVal == volume_prefNewVal ) ? "false" : "true";
   highquality_prefHasChanged = ( highquality_prefOldVal == highquality_prefNewVal ) ? "false" : "true";

   gConsole.logStringMessage(gender_prefHasChanged);
}


/*
List of VXM properties to be set :
VXM_VOICE_PARAMETER_ASR_REJECTION_THRESHOLD = 0 to 10;
MOZVXML_VOICE_PARAMETER_TTS_GENDER = 0 or 1;
MOZVXML_VOICE_PARAMETER_TTS_PITCH = 0 to 4;
MOZVXML_VOICE_PARAMETER_TTS_SPEED = 0 to 4;
MOZVXML_VOICE_PARAMETER_TTS_VOLUME = 0 to 5;
MOZVXML_VOICE_PARAMETER_TTS_CTTS = 0 or 1;
*/

function stopVXM(){
   var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
   var state = vxml.getState();
   gConsole.logStringMessage("In Preferences.js stopVXM :: State is " + state) ; 
   if (!(state & Components.interfaces.nsIVxmlInterpreter.STOPPED)){          // Check if the sate is PROCESSING. We cannot deallocate when current state is PROCESSING
      gConsole.logStringMessage("In Preferences.js stopVXM :: It is in a processing state .. Going on to stop");
      observerService.addObserver(myStopObserver, "notifyOnVxmlStateChange", false);   // Register the Observer
      vxml.cancel();                            //issue command to VXM to go to a STOP state
   }
   else if(state & Components.interfaces.nsIVxmlInterpreter.STOPPED) {
      stopped = true;
      deAllocateVXM()
   }
   // Loop on stopped = false
//   while (!stopped) { } 
// gConsole.logStringMessage("Stopped Successfully");
}

function allocateVXM(){
   var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
   var state = vxml.getState();
   gConsole.logStringMessage("In Preferences.js allocateVXM :: State is " + state) ; 
   if (state & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED){
      gConsole.logStringMessage("In Preferences.js allocateVXM :: It is in an de-allocated state .. Going on to allocate");
      vxml.allocate();
      //todo: should have state observer set these variables
      deAllocated = false;    
      stopped = false;
   }
}

function deAllocateVXM(){

   var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
   var state = vxml.getState();
   gConsole.logStringMessage("In Preferences.js deAllocateVXM :: State is " + state) ; 
   // We can only change the properties if the browser is in the deallocated state, 
   // If not deallocated then deallocate and then proceed
   
   if (!(state & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED)){
      gConsole.logStringMessage("In Preferences.js deAllocateVXM :: It is in an allocated state .. Going on to deallocate");
      // Register the Observer
      observerService.addObserver(myDeallocateObserver, "notifyOnVxmlStateChange", false);   // Register the Observer
      vxml.deallocate();
   }
   else if(state & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED) {
      deAllocated = true;
   }
}
/*
function passPreferencesToVXM(){
   if(deAllocated == true){
      gConsole.logStringMessage("In Preferences.js passPreferencesToVXM :: It is in an deallocated state .. Going on to allocate");
      var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
      var pd = vxml.getPropertyDescriptor(); 
      if (gender_prefHasChanged == "true" ) {
         pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_GENDER,gender_prefNewVal);
      }

      //allocate after all props have been set
      allocateVXM();
   }
}
*/
function passPreferencesToVXM(){
   if(deAllocated == true){
      var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
      var pd = vxml.getPropertyDescriptor(); 
      
 	  // Voice parameters.
 	  if ( confidencelevel_prefHasChanged == "true" ) {
 		   pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_ASR_REJECTION_THRESHOLD,confidencelevel_prefNewVal);
      } 
      if ( gender_prefHasChanged == "true" ) {
           pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_GENDER,gender_prefNewVal);
      }
      if ( pitch_prefHasChanged == "true" ) {
           pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_PITCH,pitch_prefNewVal);
      }
      if ( speed_prefHasChanged == "true" ) {
           pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_SPEED,speed_prefNewVal);
      }
      if ( volume_prefHasChanged == "true" ) {
           pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_VOLUME,volume_prefNewVal);
      }
      if ( enablec3n_prefHasChanged == "true" ) {
           pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_CTTS,enablec3n_prefNewVal);
      }
     
      //  Listening modes.
	  if ( talkkeymode_prefHasChanged == "true" ) {
		    if ( talkkeymode_prefNewVal == 0 ){        
		         pd.setListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_PTT);
		    }
			if ( talkkeymode_prefNewVal == 1 ){        
 				 pd.setListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_PTA);
			}
			if ( talkkeymode_prefNewVal == 3 ){        
				 pd.setListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_APTA);
			}
	  }
      //allocate after all props have been set
      allocateVXM();
   }
}

