/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla XHTML + Voice support.
 *
 * The Initial Developer of the Original Code is IBM Corporation.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Marc White <icy.nine@gmail.com>
 *  Chris Cross <xcross@us.ibm.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// X+V JavaScript

var gVxml;
var bStartListening = false;
var gConsole = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);  
var gPrefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

function pttKey(e)
{
	var pttKey = gPrefManager.getIntPref("extensions.xplusv.keytotalk");

	//e is keyboard event
	//Hardcoded to ptt mode with ScrLk. Todo: change to preferences impl and support pta
	
	//None = 0	 Insert = 45  ScrollLock = 145(default)
	if (e.which == pttKey)
	{
		//keydown keeps coming until keyup happens
		if (!bStartListening && e.type == "keydown")
		{
			bStartListening = true;
			gVxml.startListening();
		}
		if (e.type == "keyup")
		{
			bStartListening = false;
			gVxml.stopListening();
		}
	}
}

var aStateObserver = {
	observe : function(newState,topic, data)  {
		newState.QueryInterface(Components.interfaces.nsISupportsPRInt32);
   	 gConsole.logStringMessage("VXML State changed to: " + newState.data);
		// Check if the state is STOPPED
      if (newState.data & Components.interfaces.nsIVxmlInterpreter.STOPPED) {
			//stopped = true;
			//observerService.removeObserver(myStopObserver ,"notifyOnVxmlStateChange");
		}
	}
};
/*
function start()
{

   window.addEventListener("keyup", pttKey, false);
   window.addEventListener("keydown", pttKey, false);
	gVxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
	var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	os.addObserver(aStateObserver, "notifyOnVxmlStateChange", false);

	var pd = gVxml.getPropertyDescriptor();
	var state = gVxml.getState();
	if (state & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED)
   {
        var gender = gPrefManager.getIntPref("extensions.xplusv.gender");
		gConsole.logStringMessage("Set gender to: " + gender);
		pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_GENDER, gender);
		gVxml.allocate();
		
	}
}*/

function start()
{

   window.addEventListener("keyup", pttKey, false);
   window.addEventListener("keydown", pttKey, false);
   gVxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
   var os = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
   os.addObserver(aStateObserver, "notifyOnVxmlStateChange", false);

   var pd = gVxml.getPropertyDescriptor();
   var state = gVxml.getState();
   if (state & Components.interfaces.nsIVxmlInterpreter.DEALLOCATED)
   {
   		passPreferencesToVXM()
		gVxml.allocate();
	}
}

function passPreferencesToVXM(){
	//var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var vxml = Components.classes["@mozilla.org/vxml"].getService( Components.interfaces.nsIVxmlInterpreter );
    var pd = vxml.getPropertyDescriptor(); 
    
	var confidencelevel_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.confidencelevel");
	var gender_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.gender");
	var pitch_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.pitch");
	var speed_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.speed");
	var volume_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.volume");	
	var enablec3n_prefNewVal = gPrefManager.getBoolPref("extensions.xplusv.enablec3n");
	var talkkeymode_prefNewVal = gPrefManager.getIntPref("extensions.xplusv.talkkeymode");

	gConsole.logStringMessage("Set gender to: " + gender_prefNewVal);
	gConsole.logStringMessage("Set confidencelevel to: " + confidencelevel_prefNewVal);
	gConsole.logStringMessage("Set pitch to: " + pitch_prefNewVal);
	gConsole.logStringMessage("Set speed to: " + speed_prefNewVal);
	gConsole.logStringMessage("Set volume to: " + volume_prefNewVal);
	gConsole.logStringMessage("Set enablec3n to: " + enablec3n_prefNewVal);
	gConsole.logStringMessage("Set talkkeymode to: " + talkkeymode_prefNewVal);
	
   
	// Voice parameters.
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_ASR_REJECTION_THRESHOLD,confidencelevel_prefNewVal);
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_GENDER,gender_prefNewVal);
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_PITCH,pitch_prefNewVal);
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_SPEED,speed_prefNewVal);
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_VOLUME,volume_prefNewVal);
    pd.setProperty(Components.interfaces.nsIVxmlInterpreter.MOZVXML_VOICE_PARAMETER_TTS_CTTS,enablec3n_prefNewVal);
    
    // Set listening mode
    if ( talkkeymode_prefNewVal == 0 ){        
		pd.SetListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_PTT);
	}		    
	if ( talkkeymode_prefNewVal == 1 ){        
 		pd.SetListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_PTA);
	}
	if ( talkkeymode_prefNewVal == 3 ){        
		pd.SetListeningMode(Components.interfaces.nsIVxmlInterpreter.VXM_LISTENING_MODE_APTA);
	}
        
}

function XVContentHandler()
{
}

XVContentHandler.prototype =
{
  QueryInterface: function(iid)
  {
    if (iid.equals( Components.interfaces.nsIStreamListener )  ||
        iid.equals( Components.interfaces.nsIRequestObserver ) ||
        iid.equals( Components.interfaces.nsISupports )) {
      return this;
    }
    Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
    return null;
  },
  
  onStartRequest: function(aRequest, aContext)
  {
    this.data = "";
  },
  
  onStopRequest: function(aRequest, aContext, aStatusCode)
  {
    var dom = Components.classes["@mozilla.org/xmlextras/domparser;1"].getService( Components.interfaces.nsIDOMParser );
    var doc = dom.parseFromString( this.data, "application/xhtml+xml" );
    
  },
  
  onDataAvailable: function(request, context, inputStream, offset, count)
  {
    var s = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance( Components.interfaces.nsIScriptableInputStream );
    s.init( inputStream );
    this.data += s.read( inputStream.available() );
  }
}

function XVContentListener()
{
  var uriLoader = Components.classes["@mozilla.org/uriloader;1"].getService( Components.interfaces.nsIURILoader );
  if (uriLoader) {
    uriLoader.registerContentListener( this );
  }
}

XVContentListener.prototype =
{
  close: function()
  {
    var uriLoader = Components.classes["@mozilla.org/uriloader;1"].getService( Components.interfaces.nsIURILoader );
    if (uriLoader) {
      uriLoader.unRegisterContentListener( this );
    }
  },
  
  QueryInterface: function(iid)
  {
    if (iid.equals( Components.interfaces.nsIURIContentListener )    ||
        iid.equals( Components.interfaces.nsISupportsWeakReference ) ||
        iid.equals( Components.interfaces.nsISupports )) {
      return this;
    }
    Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
    return null;
  },
  
  onStartURIOpen: function(uri)
  {
    return false;
  },
  
  doContent: function(contentType, isContentPreferred, request, contentHandler)
  {
    if (contentType == "application/x-xhtml+voice+xml" || contentType == "application/xhtml+voice+xml") {
      contentHandler.value = new XVContentHandler();
  //    contentHandler.value = Components.classes["@mozilla.org/streamconv;1?from=application/x-unknown-content-type&to=*/*"].
   //                                         getService( Components.interfaces.nsIStreamListener );
  //    contentHandler.value = Components.classes["@mozilla.org/network/async-stream-listener;1"].createInstance(Components.interfaces.nsIStreamListener);
 // alert("trying xhtml+xml handler");
  //    contentHandler.value = Components.classes["@mozilla.org/uriloader/content-handler;1?type=application/xhtml+xml"].
  //                              createInstance(Components.interfaces.nsIContentHandler);
  //    contentHandler.value = Components.classes["@mozilla.org/network/input-stream-channel;1"].getService( Components.interfaces.nsIStreamListener );
    } else {
      contentHandler.value = null;
    }
    return false;
  },
  
  isPreffered: function(contentType, desiredContentType)
  {
    if (contentType == "application/x-xhtml+voice+xml" || contentType == "application/xhtml+voice+xml") {
      return true;
    }
    return false;
  },
  
  canHandleContent: function(contentType, isContentPreferred, desiredContentType)
  {
    if (contentType == "application/x-xhtml+voice+xml" || contentType == "application/xhtml+voice+xml") {
      return true;
    }
    return false;
  }
}

var xvExtension =
{

  toggleMic: function()
  {
    //alert( "xvExtension.toggleMic() called! bStartListening =  " + bStartListening);
 	 if (!bStartListening)
    {
		bStartListening = true;
		gVxml.startListening();
    }
    else
    {
		bStartListening = false;
		gVxml.stopListening();
    }
  },

  windowLoad: function()
  {
    window.removeEventListener( "load", xvExtension.windowLoad, true );
  },

  updateAcceptsHeaders: function()
  {

    //***TODO remove this accepts header on uninstall ***
    
    // add X+V content to the accepts header if not alread there
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    
    if (prefs) {
      var accepts = prefs.getCharPref("network.http.accept.default");
      if (accepts) {
        var bSetPref = false;
        if (accepts.indexOf( "application/x-xhtml+voice+xml" ) == -1) {
          var o = accepts;
          accepts = "application/x-xhtml+voice+xml," + o;
          bSetPref = true;
        }
        if (accepts.indexOf( "application/xhtml+voice+xml" ) == -1) {
          var o = accepts;
          accepts = "application/xhtml+voice+xml," + o;
          bSetPref = true;
        }
        if (bSetPref) {
          prefs.setCharPref("network.http.accept.default", accepts );
        }
      }
    }
  },
  
  registerForXVContent: function()
  {
    if (this.xvListener == null) {
      this.xvListener = new XVContentListener();
    }
  },
  
  xvListener: null
}

xvExtension.updateAcceptsHeaders();
xvExtension.registerForXVContent();
start();

// don't need this yet
//window.addEventListener( "load", xvExtension.windowLoad, true );